/****************************************************************************
                          Ant.h - description
                             -------------
begin                    : Thursday March 14 14:12:00 CET 2002
revision                 : Thursday May 29 00:47:13 CET 2003
copyright                : (C) 2002-2003 by Max Manfrin
email                    : mmanfrin@ulb.ac.be
****************************************************************************/

/****************************************************************************
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License, or      *
 *   (at your option) any later version.                                    *
 *                                                                          *
 ***************************************************************************/

#ifndef ANT_H
#define ANT_H

#include "Control_acs.h"
#include "Problem.h"
#include "Solution.h"
#include "Random.h"
#include "farthestInsertion.h"
#include "orOpt.h"

#include <limits.h>
#include <math.h>
#include <vector>

class Ant{

 public:
  
  double fitness;
  double* tauij;
  double* piij;
  double* roulette;
  Solution *currentSolution;
  vector<bool> customer_served;

  Ant();
  Ant( Random* rnd, Control_acs& control, Problem* problem);
  int solutionStep(const int step, int source, Random* rnd, Control_acs& control, Problem* problem, double** pheromoneMatrix);
  ~Ant();
};

#endif
