#include "Control_acs.h"

Control_acs::Control_acs( int argc, char** argv ) : Control( argc, argv) {

	// check for COLONYSIZE parameter
	
	if( parameterExists( "-colonysize" ) ) {
		COLONYSIZE = getIntParameter( "-colonysize" );
	} else {
		COLONYSIZE = 7; // default number of ants
	}

	// check for TAU0 parameter
	
	if( parameterExists( "-tau0" ) ) {
		TAU0 = getDoubleParameter( "-tau0" );
	} else {
		TAU0 = 0.5; // default pheromone value
	}

	// check for RHO parameter
	
	if( parameterExists( "-rho" ) ) {
		RHO = getDoubleParameter( "-rho" );
	} else {
		RHO = 0.1; // default global update rule pheromone value
	}

	// check for PSI parameter
	
	if( parameterExists( "-psi" ) ) {
		PSI = getDoubleParameter( "-psi" );
	} else {
		PSI = 0.3; // default local update rule pheromone value
	}

	// check for Q parameter
	
	if( parameterExists( "-Q" ) ) {
		Q = getDoubleParameter( "-Q" );
	} else {
		Q = 10000000.0; // default global update rule Q value
	}

	// check for ALPHA parameter
	
	if( parameterExists( "-alpha" ) ) {
		ALPHA = getDoubleParameter( "-alpha" );
	} else {
		ALPHA = 1; // default value for pheromone exponent power 
	}

	//Print ot output stream the command line parameters.
	(*os) << endl;
	(*os) << "ACS Specific Parameters:" << endl;
	(*os) << "Colony size " << COLONYSIZE << endl;
	(*os) << "Initial value in pheromone matrix " << TAU0 << endl;
	(*os) << "Global update Rule pheromone value " << RHO << endl;
	(*os) << "Local update Rule pheromone value " << PSI << endl;	
	(*os) << "Global update Rule Q value " << Q << endl;
	(*os) << "Pheromone exponent value " << ALPHA << endl;
	(*os) << endl;
	
}

Control_acs::~Control_acs() {
}
