#ifndef CONTROL_ACS_H
#define CONTROL_ACS_H

/*
	This is VRPSD's control class for acs.  
*/

#include "Control.h"


class Control_acs: public Control {
 private:
  double TAU0;    // Initial pheromone value
  double ALPHA;   // Pheromone information
  double BETA;    // Heuristic information: distances
  double GAMMA;   // Heuristic information: capacity
  double RHO;     // Global update rule - pheromone factor
  double PSI;     // Local update rule - pheromone factor
  int COLONYSIZE; // Size of population
  double Q;       // Gloal upate rule - multiplier factor

 public:
   Control_acs( int, char** ); // construct a control object, given a set of command line options
   ~Control_acs();
   double getTAU0() { return TAU0; }
   double getALPHA() { return ALPHA; }
   double getBETA() { return BETA; }
   double getGAMMA() { return GAMMA; }
   double getRHO() { return RHO; }
   double getPSI() { return PSI; }
   int getCOLONYSIZE() { return COLONYSIZE; }
   double getQ() { return Q; } 
};

#endif
